<template>
  <div div="user">
    <b-jumbotron>
      <template slot="header">Available groups</template>

      <div>
        <b-alert
          :show="hasError"
          dismissible
          variant="danger"
        >{{ alertMessage }}</b-alert>
      </div>
      <div class="mydiv-tablealign">
        <table class="table table-bordered">
          <thead>
            <tr>
              <th>Group</th>
            </tr>
          </thead>
          <tr v-for="group in groups" class="static" v-bind:key="group">
            <td @click="dispatchToGroup(group)">{{group}}</td>
          </tr>
        </table>
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  data() {
    return {
      groups: [],
      alertMessage: "Request error",
      hasError: false
    };
  },
  created() {
    this.loadItems()
  },
  beforeRouteUpdate (_, __, next) {
    this.loadItems();
    next();
  },
  methods: {
    loadItems() {
      AXIOS.get(`/edu/groups`, {})
      .then(
        response => {
          console.log(response);
          this.groups = response.data;
          this.hasError = false;
        },
        error => {
          console.log(error);
          this.$data.alertMessage =
            error.response.data.length < 150
              ? error.response.data
              : "Request error. Please, report this error website owners";
          this.hasError = true;
          this.groups = [];
        }
      )
      .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.groups = [];
          this.hasError = true;
        });
    },
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    dispatchToGroup(name) {
      this.$router.push({ name: "Group", params: { groupName: name } });
    }
  }
};
</script>

<style>
.mydiv-tablealign{
	text-align:center
}
</style>